## rawtherapee 4.0.9

=== CMakeLists.txt ===
if (WIN32)
  cmake_minimum_required(VERSION 2.8.4)
  cmake_policy(SET CMP0015 OLD)
else (WIN32)
  cmake_minimum_required(VERSION 2.6)
endif (WIN32)

# the default target is 'Debug'
if (CMAKE_BUILD_TYPE STREQUAL "")
  set (CMAKE_BUILD_TYPE Debug CACHE STRING "One of: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif ()

string (TOUPPER ${CMAKE_BUILD_TYPE} UPPER_CMAKE_BUILD_TYPE)

if (UPPER_CMAKE_BUILD_TYPE STREQUAL "DEBUG")
  add_definitions (-D_DEBUG)
endif ()

message(STATUS "CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}")

set (CACHE_NAME_SUFFIX "" CACHE STRING "RawTherapee's cache folder suffix (leave empty to use the default suffix, i.e. latesttag)")

# By default, we don't use specific processor target, so  PROC_TARGET_NUMBER is set to 0. If can specify other values to select specific
# processor targets, which list can be found in ProcessorTargets.cmake.
set (PROC_TARGET_NUMBER 0 CACHE STRING "Selected target processor from the list above (taken from ProcessorTargets.cmake)")

# The following line set special compilation flags for RTEngine, and will be added to CMAKE_CXX_FLAGS
# It were moved away from rtengine/CMakefiles.txt, because some users may want to remove -ffast_math :
# this flag speeds up the floating-point operations, but with a little bite less precisions. This default value
# gives the same result/behaviour as before.
set (RTENGINE_CXX_FLAGS "-ffast-math -funroll-loops" CACHE STRING "Special compilation flags for RTEngine")

#loading the processor targets list
include (ProcessorTargets.cmake)
set (PROC_LABEL "undefined" CACHE STRING "Target processor label, unused if PROC_TARGET_NUMBER = 0 or 2")
set (PROC_FLAGS "" CACHE STRING "Target processor related build/link flags")
if ((NOT(PROC_TARGET_NUMBER EQUAL 0)) AND (NOT(PROC_TARGET_NUMBER EQUAL 2)))
	set (PROC_LABEL ${PROC_TARGET_${PROC_TARGET_NUMBER}_LABEL})
endif ()
if (NOT(PROC_TARGET_NUMBER EQUAL 0))
	set (PROC_FLAGS ${PROC_TARGET_${PROC_TARGET_NUMBER}_FLAGS})
endif ()

# if it exists, the PROC_FORCED_LABEL value is loaded in PROC_LABEL to override the one of ProcessorTargets
if (DEFINED PROC_FORCED_LABEL)
  set (PROC_LABEL ${PROC_FORCED_LABEL})
endif (DEFINED PROC_FORCED_LABEL)

# adding the proc flags to the build flags
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${PROC_FLAGS}")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${PROC_FLAGS}")
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${PROC_FLAGS}")

if (WIN32)
    # we additionnally look in the MinGW path first then in the Gtkmm path,
    # so if you wish to build some dependant library, you have to install them in MinGW to use them
    set(CMAKE_PREFIX_PATH $ENV{MINGW_BASEPATH} $ENV{GTKMM_BASEPATH} CACHE STRING "Additional search paths")
endif (WIN32)

if (APPLE)
#    SET (CMAKE_OSX_ARCHITECTURES "i386;x86_64;" )
#    SET (CMAKE_TRY_COMPILE_OSX_ARCHITECTURES "i386;x86_64;" )
    SET (CMAKE_OSX_SYSROOT "/Developer/SDKs/MacOSX10.5.sdk")
    SET (CMAKE_OSX_DEPLOYMENT_TARGET "10.5")
endif (APPLE)

option(USE_CLANG "Build rawtherapee with clang" OFF)
option(USE_EXPERIMENTAL_LANG_VERSIONS "Build RT with -std=c++0x" OFF)
option (AUTOMATED_BUILD_SYSTEM "TRUE if built by an automate" OFF)

option (BUILD_SHARED "Build rawtherapee with shared libraries" OFF)
option (WITH_BZIP "Build with Bzip2 support" ON)
option (WITH_MYFILE_MMAP "Build using memory mapped file" ON)
option (OPTION_OMP "Build with OpenMP support" ON)
option (BUILD_BUNDLE "Self-contained build" OFF)

# set install directories
if (WIN32 OR APPLE)
    set (BUILD_BUNDLE ON FORCE)
endif(WIN32 OR APPLE)

if (NOT DEFINED BUNDLE_BASE_INSTALL_DIR)
    set (BUNDLE_BASE_INSTALL_DIR  ${CMAKE_CURRENT_SOURCE_DIR}/${CMAKE_BUILD_TYPE})
endif (NOT DEFINED BUNDLE_BASE_INSTALL_DIR)

if (BUILD_BUNDLE)
    set (BINDIR .)
    set (CMAKE_INSTALL_PREFIX ${BUNDLE_BASE_INSTALL_DIR})
endif (BUILD_BUNDLE)

if (NOT DEFINED BINDIR)
    set (BINDIR  ${CMAKE_INSTALL_PREFIX}/bin)
endif (NOT DEFINED BINDIR)

if (NOT DEFINED DATADIR)
    if (BUILD_BUNDLE)
        set (DATADIR .)
    else (BUILD_BUNDLE)
        set (DATADIR ${CMAKE_INSTALL_PREFIX}/share/rawtherapee)
    endif (BUILD_BUNDLE)
endif (NOT DEFINED DATADIR)

if (NOT DEFINED LIBDIR)
    if (BUILD_BUNDLE)
        set (LIBDIR .)
    else (BUILD_BUNDLE)
        # Respect CMAKE_INSTALL_LIBDIR if set
        if (DEFINED CMAKE_INSTALL_LIBDIR)
	    if (IS_ABSOLUTE ${LIBDIR})
            	set (LIBDIR ${CMAKE_INSTALL_LIBDIR})
	    else (IS_ABSOLUTE ${LIBDIR})
		set (LIBDIR ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR})
	    endif (IS_ABSOLUTE ${LIBDIR})
        else (DEFINED CMAKE_INSTALL_LIBDIR)
            set (LIBDIR ${CMAKE_INSTALL_PREFIX}/lib)
        endif (DEFINED CMAKE_INSTALL_LIBDIR)
    endif (BUILD_BUNDLE)
endif (NOT DEFINED LIBDIR)

if (NOT DEFINED DOCDIR)
    if (BUILD_BUNDLE)
        set (DOCDIR ./doc)
    else (BUILD_BUNDLE)
        set (DOCDIR ${CMAKE_INSTALL_PREFIX}/share/doc/rawtherapee)
    endif (BUILD_BUNDLE)
endif (NOT DEFINED DOCDIR)

if (NOT DEFINED CREDITSDIR)
    if (BUILD_BUNDLE)
        set (CREDITSDIR .)
    else (BUILD_BUNDLE)
        set (CREDITSDIR ${CMAKE_INSTALL_PREFIX}/share/doc/rawtherapee)
    endif (BUILD_BUNDLE)
endif (NOT DEFINED CREDITSDIR)

if (NOT DEFINED LICENCEDIR)
    if (BUILD_BUNDLE)
        set (LICENCEDIR .)
    else (BUILD_BUNDLE)
        set (LICENCEDIR ${CMAKE_INSTALL_PREFIX}/share/doc/rawtherapee)
    endif (BUILD_BUNDLE)
endif (NOT DEFINED LICENCEDIR)

if (NOT DEFINED DESKTOPDIR)
    if (UNIX)
        set (DESKTOPDIR ${CMAKE_INSTALL_PREFIX}/share/applications)
    endif (UNIX)
endif (NOT DEFINED DESKTOPDIR)

if (NOT DEFINED ICONSDIR)
    if (UNIX)
        set (ICONSDIR ${CMAKE_INSTALL_PREFIX}/share/icons)
    endif (UNIX)
endif (NOT DEFINED ICONSDIR)

# non-bundle builds has to use absolute paths
if (NOT BUILD_BUNDLE AND
    NOT (IS_ABSOLUTE ${BINDIR} AND IS_ABSOLUTE ${DATADIR} AND IS_ABSOLUTE ${LIBDIR} AND
    IS_ABSOLUTE ${DOCDIR} AND IS_ABSOLUTE ${CREDITSDIR} AND IS_ABSOLUTE ${LICENCEDIR}))
    message (FATAL_ERROR "The paths has to be absolute or use -DBUILD_BUNDLE=ON")
endif ()

# check for libraries
find_package(PkgConfig)
pkg_check_modules (GTK     REQUIRED gtk+-2.0>=2.12)
pkg_check_modules (GLIB2   REQUIRED glib-2.0>=2.16)
pkg_check_modules (GLIBMM  REQUIRED glibmm-2.4>=2.16)
pkg_check_modules (GTKMM   REQUIRED gtkmm-2.4>=2.12)
pkg_check_modules (GIO     REQUIRED gio-2.0>=2.16)
pkg_check_modules (GIOMM   REQUIRED giomm-2.4>=2.12)
pkg_check_modules (GTHREAD REQUIRED gthread-2.0>=2.16)
pkg_check_modules (GOBJECT REQUIRED gobject-2.0>=2.16)
pkg_check_modules (SIGC    REQUIRED sigc++-2.0)
# NOTE: The new mechanism has been tested with BUILD_SHARED = OFF
if (WIN32)
    add_definitions (-DWIN32)
    add_definitions (-D_WIN32)
    if (MINGW)
        add_definitions (-D__MINGW32__)
    endif (MINGW)

    set (EXTRA_LIB "-lws2_32")
endif (WIN32)
# you may need lcms v1.xx for older version : pkg_check_modules (LCMS REQUIRED lcms<=1.99)
pkg_check_modules (LCMS REQUIRED lcms2)
find_package (EXPAT REQUIRED expat>=2.0)
pkg_check_modules (IPTCDATA REQUIRED libiptcdata)
find_package (JPEG REQUIRED)
find_package (PNG REQUIRED)
find_package (TIFF REQUIRED)
find_package (ZLIB REQUIRED)

if (AUTOMATED_BUILD_SYSTEM)

	message(WARNING "Automated build system mode! You have to make sure that AboutThisBuild.txt and rtgui/version.h are up-to-date by building RT at least one time with AUTOMATED_BUILD_SYSTEM=OFF.")

  # Checking for the presence of AboutThisBuild.txt
  find_file(ABOUT_FILE AboutThisBuild.txt PATHS "${CMAKE_CURRENT_SOURCE_DIR}" NO_DEFAULT_PATH)
  if (ABOUT_FILE STREQUAL ABOUT_FILE-NOTFOUND)
	  message(FATAL_ERROR "AboutThisBuild.txt not found! You have to build RT at least one time with AUTOMATED_BUILD_SYSTEM=OFF to generate this file.")
  endif (ABOUT_FILE STREQUAL ABOUT_FILE-NOTFOUND)

  # Checking for the presence of version.h
  find_file(VERSION_FILE version.h PATHS "${CMAKE_CURRENT_SOURCE_DIR}/rtgui" NO_DEFAULT_PATH)
  if (VERSION_FILE STREQUAL VERSION_FILE-NOTFOUND)
	  message(FATAL_ERROR "rtgui/version.h not found! You have to build RT at least one time with AUTOMATED_BUILD_SYSTEM=OFF to generate this file.")
  endif (VERSION_FILE STREQUAL VERSION_FILE-NOTFOUND)

else (AUTOMATED_BUILD_SYSTEM)

  # set the bit number information of the platform
  if (CMAKE_SIZEOF_VOID_P EQUAL 4)
    set(PROC_BIT_DEPTH 32 bits)
  elseif (CMAKE_SIZEOF_VOID_P EQUAL 8)
    set(PROC_BIT_DEPTH 64 bits)
  endif (CMAKE_SIZEOF_VOID_P EQUAL 4)

  #generating AboutThisBuild.txt
  if (WIN32)

    add_custom_target (AboutFile ALL
      COMMAND ${CMAKE_COMMAND}
              -DSRC_DIR:STRING=${CMAKE_CURRENT_SOURCE_DIR}
              -DCACHE_NAME_SUFFIX:STRING=${CACHE_NAME_SUFFIX}
              -DSYSTEM:STRING=Windows
              -DPROC_LABEL:STRING=\"${PROC_LABEL}\"
              -DPROC_BIT_DEPTH:STRING=\"${PROC_BIT_DEPTH}\"
              -DBUILD_TYPE:STRING=${CMAKE_BUILD_TYPE}
              -DGTKMM_VERSION:STRING=${GTKMM_VERSION}
              -DCXX_FLAGS:STRING=\"${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_${UPPER_CMAKE_BUILD_TYPE}}\"
              -DLFLAGS:STRING=\"${CMAKE_EXE_LINKER_FLAGS} ${CMAKE_EXE_LINKER_FLAGS_${UPPER_CMAKE_BUILD_TYPE}}\"
              -DOPTION_OMP:STRING=${OPTION_OMP}
              -DWITH_MYFILE_MMAP:STRING=${WITH_MYFILE_MMAP}
              -P ${CMAKE_CURRENT_SOURCE_DIR}/AboutThisBuild.cmake
      COMMENT "Creating the about file"
    )
    find_file(HG_CMD hg.exe HINTS ENV Path PATH_SUFFIXES ../)

  elseif (APPLE)
 
    add_custom_target (AboutFile ALL
      COMMAND ${CMAKE_COMMAND}
              -DSRC_DIR:STRING=${CMAKE_CURRENT_SOURCE_DIR}
              -DCACHE_NAME_SUFFIX:STRING=${CACHE_NAME_SUFFIX}
              -DSYSTEM:STRING=Apple
              -DPROC_LABEL:STRING=\"${PROC_LABEL}\"
              -DPROC_BIT_DEPTH:STRING=\"${PROC_BIT_DEPTH}\"
              -DBUILD_TYPE:STRING=${CMAKE_BUILD_TYPE}
              -DGTKMM_VERSION:STRING=${GTKMM_VERSION}
              -DCXX_FLAGS:STRING=${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_${UPPER_CMAKE_BUILD_TYPE}}
              -DLFLAGS:STRING=${CMAKE_EXE_LINKER_FLAGS} ${CMAKE_EXE_LINKER_FLAGS_${UPPER_CMAKE_BUILD_TYPE}}
              -DOPTION_OMP:STRING=${OPTION_OMP}
              -DWITH_MYFILE_MMAP:STRING=${WITH_MYFILE_MMAP}
              -P ${CMAKE_CURRENT_SOURCE_DIR}/AboutThisBuild.cmake
      COMMENT "Creating the about file"
    )
    find_file(HG_CMD hg PATHS "/opt/local/bin" "/usr/local/bin" "/usr/bin")
    find_file(HG_CMD hg)

  else (WIN32)
 
    add_custom_target (AboutFile ALL
      COMMAND ${CMAKE_COMMAND}
              -DSRC_DIR:STRING=${CMAKE_CURRENT_SOURCE_DIR}
              -DCACHE_NAME_SUFFIX:STRING=${CACHE_NAME_SUFFIX}
              -DSYSTEM:STRING=Linux
              -DPROC_LABEL:STRING=\"${PROC_LABEL}\"
              -DPROC_BIT_DEPTH:STRING=\"${PROC_BIT_DEPTH}\"
              -DBUILD_TYPE:STRING=${CMAKE_BUILD_TYPE}
              -DGTKMM_VERSION:STRING=${GTKMM_VERSION}
              -DCXX_FLAGS:STRING=${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_${UPPER_CMAKE_BUILD_TYPE}}
              -DLFLAGS:STRING=${CMAKE_EXE_LINKER_FLAGS} ${CMAKE_EXE_LINKER_FLAGS_${UPPER_CMAKE_BUILD_TYPE}}
              -DOPTION_OMP:STRING=${OPTION_OMP}
              -DWITH_MYFILE_MMAP:STRING=${WITH_MYFILE_MMAP}
              -P ${CMAKE_CURRENT_SOURCE_DIR}/AboutThisBuild.cmake
      COMMENT "Creating the about file"
    )
    find_file(HG_CMD hg)

  endif (WIN32)
 
  add_dependencies(AboutFile Debug Release MinSizeRel RelWithDebInfo)

  if (HG_CMD STREQUAL HG_CMD-NOTFOUND)
    message(FATAL_ERROR "hg command not found!")
  else (HG_CMD STREQUAL HG_CMD-NOTFOUND)
    message(STATUS "hg command found: ${HG_CMD}")
  endif (HG_CMD STREQUAL HG_CMD-NOTFOUND)

endif (AUTOMATED_BUILD_SYSTEM)


# link witz bzip
if (WITH_BZIP)
  find_package(BZip2)
  if (BZIP2_FOUND)
    add_definitions (-DBZIP_SUPPORT)
    set (EXTRA_INCDIR ${EXTRA_LIB} ${BZIP2_INCLUDE_DIR})
    set (EXTRA_LIB ${EXTRA_LIB} ${BZIP2_LIBRARIES})
  endif (BZIP2_FOUND)
endif (WITH_BZIP)

if (WITH_MYFILE_MMAP)
	add_definitions (-DMYFILE_MMAP)

=== rtdata/CMakeLists.txt ===

file (GLOB PROFILEFILES "profiles/*.pp3")
file (GLOB LANGUAGEFILES "languages/*")
file (GLOB SOUNDFILES "sounds/*")
file (GLOB INPUTICCFILES "iccprofiles/input/*")
file (GLOB OUTPUTICCFILES "iccprofiles/output/*")
file (GLOB DCPFILES "dcpprofiles/*")
# THEMEDIR includes subfolders for image resources for some themes; doing the normal glob won't work.
set (THEMEDIR "themes")
set (IMAGESDIR "images")

if (WIN32)
    set(OPTIONSFILE "options/options.win")
elseif (APPLE)
    set(OPTIONSFILE "options/options.osx")
else (WIN32)
    set(OPTIONSFILE "options/options.lin")
endif (WIN32)

if (UNIX)
    configure_file (${CMAKE_CURRENT_SOURCE_DIR}/icons/rawtherapee.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/rawtherapee.desktop)
    install (FILES ${CMAKE_CURRENT_BINARY_DIR}/rawtherapee.desktop DESTINATION ${DESKTOPDIR})
    install (FILES ${CMAKE_CURRENT_SOURCE_DIR}/icons/hi16-app-rawtherapee.png DESTINATION ${ICONSDIR}/hicolor/16x16/apps RENAME rawtherapee.png)
    install (FILES ${CMAKE_CURRENT_SOURCE_DIR}/icons/hi24-app-rawtherapee.png DESTINATION ${ICONSDIR}/hicolor/24x24/apps RENAME rawtherapee.png)
    install (FILES ${CMAKE_CURRENT_SOURCE_DIR}/icons/hi32-app-rawtherapee.png DESTINATION ${ICONSDIR}/hicolor/32x32/apps RENAME rawtherapee.png)
    install (FILES ${CMAKE_CURRENT_SOURCE_DIR}/icons/hi48-app-rawtherapee.png DESTINATION ${ICONSDIR}/hicolor/48x48/apps RENAME rawtherapee.png)
    install (FILES ${CMAKE_CURRENT_SOURCE_DIR}/icons/hi128-app-rawtherapee.png DESTINATION ${ICONSDIR}/hicolor/128x128/apps RENAME rawtherapee.png)
    install (FILES ${CMAKE_CURRENT_SOURCE_DIR}/icons/hi256-app-rawtherapee.png DESTINATION ${ICONSDIR}/hicolor/256x256/apps RENAME rawtherapee.png)
endif (UNIX)

install (FILES ${IMAGEFILES} DESTINATION ${DATADIR}/images)
install (FILES ${LANGUAGEFILES} DESTINATION ${DATADIR}/languages)
install (FILES ${PROFILEFILES} DESTINATION ${DATADIR}/profiles)
install (FILES ${SOUNDFILES} DESTINATION ${DATADIR}/sounds)
install (FILES ${INPUTICCFILES} DESTINATION ${DATADIR}/iccprofiles/input)
install (FILES ${OUTPUTICCFILES} DESTINATION ${DATADIR}/iccprofiles/output)
install (FILES ${DCPFILES} DESTINATION ${DATADIR}/dcpprofiles)
install (DIRECTORY ${THEMEDIR} DESTINATION ${DATADIR})
install (DIRECTORY ${IMAGESDIR} DESTINATION ${DATADIR} FILES_MATCHING PATTERN "index.theme")
install (DIRECTORY ${IMAGESDIR} DESTINATION ${DATADIR} FILES_MATCHING PATTERN "*.png")
install (FILES ${OPTIONSFILE} DESTINATION ${DATADIR} PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ RENAME options)

=== rtengine/CMakeLists.txt ===
include_directories (${EXTRA_INCDIR} ${GTHREAD_INCLUDE_DIRS} ${GOBJECT_INCLUDE_DIRS} ${GLIB2_INCLUDE_DIRS}
    ${GLIBMM_INCLUDE_DIRS} ${IPTCDATA_INCLUDE_DIRS} ${LCMS_INCLUDE_DIRS} ${EXPAT_INCLUDE_DIRS}
    ${GTKMM_INCLUDE_DIRS} ${GTK_INCLUDE_DIRS})
link_directories (${CMAKE_CURRENT_SOURCE_DIR}/../rtexif ${EXTRA_LIBDIR} ${GTHREAD_LIBRARY_DIRS}
    ${GOBJECT_LIBRARY_DIRS} ${GLIB2_LIBRARY_DIRS} ${GLIBMM_LIBRARY_DIRS}
    ${IPTCDATA_LIBRARY_DIRS} ${LCMS_LIBRARY_DIRS} ${EXPAT_LIBRARY_DIRS})

set (RTENGINESOURCEFILES safegtk.cc colortemp.cc curves.cc flatcurves.cc diagonalcurves.cc dcraw.cc iccstore.cc
    dfmanager.cc ffmanager.cc rawimage.cc image8.cc image16.cc imagefloat.cc imagedata.cc imageio.cc improcfun.cc init.cc dcrop.cc
    loadinitial.cc procparams.cc rawimagesource.cc demosaic_algos.cc shmap.cc simpleprocess.cc refreshmap.cc
    stdimagesource.cc myfile.cc iccjpeg.cc hlmultipliers.cc improccoordinator.cc
    processingjob.cc rtthumbnail.cc utils.cc labimage.cc slicer.cc
    iplab2rgb.cc ipsharpen.cc iptransform.cc ipresize.cc ipvibrance.cc
	jpeg_memsrc.cc jdatasrc.cc
	PF_correct_RT.cc
    dirpyrLab_denoise.cc dirpyrLab_equalizer.cc dirpyr_equalizer.cc
    calc_distort.cc lcp.cc dcp.cc
    klt/convolve.cc klt/error.cc klt/klt.cc klt/klt_util.cc klt/pnmio.cc klt/pyramid.cc klt/selectGoodFeatures.cc
    klt/storeFeatures.cc klt/trackFeatures.cc klt/writeFeatures.cc
    )

add_library (rtengine ${RTENGINESOURCEFILES})
#It may be nice to store library version too
IF (BUILD_SHARED_LIBS)
    install (TARGETS rtengine DESTINATION ${LIBDIR})
ENDIF (BUILD_SHARED_LIBS)

set_target_properties (rtengine PROPERTIES COMPILE_FLAGS "${RTENGINE_CXX_FLAGS}")

target_link_libraries (rtengine rtexif ${EXTRA_LIB} ${GOBJECT_LIBRARIES} ${GTHREAD_LIBRARIES}
    ${GLIB2_LIBRARIES} ${GLIBMM_LIBRARIES} ${LCMS_LIBRARIES} ${EXPAT_LIBRARIES} ${IPTCDATA_LIBRARIES}
    ${JPEG_LIBRARIES} ${PNG_LIBRARIES} ${TIFF_LIBRARIES} ${ZLIB_LIBRARIES})

=== rtexif/CMakeLists.txt ===
add_library (rtexif rtexif.cc stdattribs.cc nikonattribs.cc canonattribs.cc
    pentaxattribs.cc fujiattribs.cc sonyminoltaattribs.cc olympusattribs.cc)

IF (WIN32)
    set_target_properties (rtexif PROPERTIES COMPILE_FLAGS " -ffast-math -fexpensive-optimizations")
    include_directories (${EXTRA_INCDIR} ${GLIB2_INCLUDE_DIRS} ${GLIBMM_INCLUDE_DIRS}
        ${GTK_INCLUDE_DIRS} ${GTKMM_INCLUDE_DIRS})
    link_directories (. ../rtexif ${EXTRA_LIBDIR} ${GLIB2_LIBRARY_DIRS} ${GLIBMM_LIBRARY_DIRS}
        ${GTK_LIBRARY_DIRS} ${GTKMM_LIBRARY_DIRS})
    #set_target_properties (rth PROPERTIES LINK_FLAGS "-mwindows")
ELSE (WIN32)
    set_target_properties (rtexif PROPERTIES COMPILE_FLAGS " -ffast-math -fexpensive-optimizations -fPIC")
    include_directories (${EXTRA_INCDIR} ${GLIB2_INCLUDE_DIRS}
        ${GLIBMM_INCLUDE_DIRS} ${GTK_INCLUDE_DIRS} ${GTKMM_INCLUDE_DIRS})
    link_directories (${EXTRA_LIBDIR} ${GLIB2_LIBRARY_DIRS}
        ${GLIBMM_LIBRARY_DIRS} ${GTK_LIBRARY_DIRS} ${GTKMM_LIBRARY_DIRS})
ENDIF (WIN32)

IF (BUILD_SHARED_LIBS)
    INSTALL(TARGETS rtexif DESTINATION ${LIBDIR})
ENDIF (BUILD_SHARED_LIBS)

=== rtgui/CMakeLists.txt ===

set (BASESOURCEFILES
    editwindow.cc batchtoolpanelcoord.cc paramsedited.cc cropwindow.cc previewhandler.cc previewwindow.cc navigator.cc indclippedpanel.cc previewmodepanel.cc filterpanel.cc
    exportpanel.cc cursormanager.cc rtwindow.cc renamedlg.cc recentbrowser.cc placesbrowser.cc filepanel.cc editorpanel.cc batchqueuepanel.cc
    ilabel.cc thumbbrowserbase.cc adjuster.cc filebrowserentry.cc filebrowser.cc filethumbnailbuttonset.cc
    cachemanager.cc cacheimagedata.cc shcselector.cc perspective.cc
    clipboard.cc thumbimageupdater.cc bqentryupdater.cc lensgeom.cc
    coarsepanel.cc cacorrection.cc hlrec.cc chmixer.cc
    resize.cc icmpanel.cc crop.cc shadowshighlights.cc
    impulsedenoise.cc dirpyrdenoise.cc epd.cc
    exifpanel.cc toolpanel.cc lensprofile.cc
    sharpening.cc vibrance.cc rgbcurves.cc
    whitebalance.cc   vignetting.cc rotate.cc distortion.cc
    crophandler.cc dirbrowser.cc
    curveeditor.cc curveeditorgroup.cc diagonalcurveeditorsubgroup.cc flatcurveeditorsubgroup.cc
    filecatalog.cc extprog.cc
    previewloader.cc rtimage.cc
    histogrampanel.cc history.cc  imagearea.cc
    imageareapanel.cc iptcpanel.cc labcurve.cc main.cc
    multilangmgr.cc mycurve.cc myflatcurve.cc mydiagonalcurve.cc options.cc
    preferences.cc profilepanel.cc saveasdlg.cc
    saveformatpanel.cc soundman.cc splash.cc
    thumbnail.cc tonecurve.cc toolbar.cc
    guiutils.cc zoompanel.cc toolpanelcoord.cc
    thumbbrowserentrybase.cc batchqueueentry.cc
    batchqueue.cc lwbutton.cc lwbuttonset.cc
    batchqueuebuttonset.cc browserfilter.cc exiffiltersettings.cc
    profilestore.cc partialpastedlg.cc rawprocess.cc preprocess.cc
    darkframe.cc flatfield.cc rawcacorrection.cc rawexposure.cc
    dirpyrequalizer.cc hsvequalizer.cc defringe.cc
    popupcommon.cc popupbutton.cc popuptogglebutton.cc sharpenedge.cc sharpenmicro.cc)

if (WIN32)
    set (EXTRA_SRC windirmonitor.cc myicon.rc)
    set (EXTRA_LIB_RTGUI winmm)
    include_directories (${EXTRA_INCDIR} ${GLIB2_INCLUDE_DIRS} ${GLIBMM_INCLUDE_DIRS}
        ${GTK_INCLUDE_DIRS} ${GTKMM_INCLUDE_DIRS} ${GIO_INCLUDE_DIRS} ${GIOMM_INCLUDE_DIRS})
    link_directories (. ../rtexif ${EXTRA_LIBDIR} ${GLIB2_LIBRARY_DIRS} ${GLIBMM_LIBRARY_DIRS}
        ${GTK_LIBRARY_DIRS} ${GTKMM_LIBRARY_DIRS} ${GIO_LIBRARY_DIRS} ${GIOMM_LIBRARY_DIRS})
    #set_target_properties (rth PROPERTIES LINK_FLAGS "-mwindows")
else (WIN32)
    include_directories (${EXTRA_INCDIR} ${GLIB2_INCLUDE_DIRS} ${GLIBMM_INCLUDE_DIRS}
        ${GTK_INCLUDE_DIRS} ${GTKMM_INCLUDE_DIRS} ${GIO_INCLUDE_DIRS} ${GIOMM_INCLUDE_DIRS} ${IPTCDATA_INCLUDE_DIRS} ${LCMS_INCLUDE_DIRS} ${EXPAT_INCLUDE_DIRS} ${GTHREAD_INCLUDE_DIRS} ${GOBJECT_INCLUDE_DIRS} )
    link_directories (${EXTRA_LIBDIR} ${GLIB2_LIBRARY_DIRS} ${GLIBMM_LIBRARY_DIRS}
        ${GTK_LIBRARY_DIRS} ${GTKMM_LIBRARY_DIRS} ${GIO_LIBRARY_DIRS} ${GIOMM_LIBRARY_DIRS} ${IPTCDATA_LIBRARY_DIRS} ${LCMS_LIBRARY_DIRS} ${EXPAT_LIBRARY_DIRS} ${GTHREAD_LIBRARY_DIRS} ${GOBJECT_LIBRARY_DIRS})
endif (WIN32)
# create config.h which defines where data are stored
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/config.h.in ${CMAKE_CURRENT_SOURCE_DIR}/config.h)

add_executable (rth ${EXTRA_SRC} ${BASESOURCEFILES})

set_target_properties (rth PROPERTIES COMPILE_FLAGS "${CMAKE_CXX_FLAGS}" OUTPUT_NAME rawtherapee)
#target_link_libraries (rth rtengine ${JPEG_LIBRARIES} ${PNG_LIBRARIES} ${ZLIB_LIBRARIES} ${TIFF_LIBRARIES} ${EXTRA_LIB} ${GOBJECT_LIBRARIES} ${GTHREAD_LIBRARIES}
#   ${GLIB2_LIBRARIES} ${GLIBMM_LIBRARIES} ${GTK_LIBRARIES} ${GTKMM_LIBRARIES} ${GIO_LIBRARIES} ${GIOMM_LIBRARIES} ${LCMS_LIBRARIES} ${IPTCDATA_LIBRARIES})
target_link_libraries (rth rtengine ${JPEG_LIBRARIES} ${PNG_LIBRARIES} ${ZLIB_LIBRARIES} ${TIFF_LIBRARIES} ${GOBJECT_LIBRARIES} ${GTHREAD_LIBRARIES}
   ${GLIB2_LIBRARIES} ${GLIBMM_LIBRARIES} ${GTK_LIBRARIES} ${GTKMM_LIBRARIES} ${GIO_LIBRARIES} ${GIOMM_LIBRARIES} ${LCMS_LIBRARIES} ${EXPAT_LIBRARIES} ${IPTCDATA_LIBRARIES} ${EXTRA_LIB_RTGUI})
install (TARGETS rth DESTINATION ${BINDIR})

=== debian/changelog ===
rawtherapee (4.0.9-4+deb7u1) wheezy; urgency=high

  * Add patch debian/patches/04-fix_CVE-2015-3885.patch:
    - Fix dcraw imput sanitization errors (CVE-2015-3885)

 -- Philip Rinn <rinni@inventati.org>  Tue, 09 June 2015 20:52:45 +0200

rawtherapee (4.0.9-4) unstable; urgency=low

  * Fix RC bug that corrupts EXIF data in some cases (closes: #693736):
     - add debian/patches/03-fix_exif_corruption.patch: Use the correct
       size for multibyte EXIF tags which use TagDirectoryTable

 -- Philip Rinn <rinni@gmx.net>  Mon, 19 Nov 2012 21:11:43 +0000

rawtherapee (4.0.9-3) unstable; urgency=low

  * Fix upgrade failure to testing (closes: #677575).
  * Build-depend on libtiff-dev instead of libtiff4-dev.

 -- Philip Rinn <rinni@gmx.net>  Fri, 15 June 2012 10:43:12 +0100

rawtherapee (4.0.9-2) unstable; urgency=low

  * Fix build failures (closes: #677293):
    - use override_dh_install-{arch,indep} in debian/rules
  * Add patch debian/patches/02-fix_color_artifacts.patch:
    - fix color artifacts (from upstream)

 -- Philip Rinn <rinni@gmx.net>  Wed, 13 June 2012 20:01:54 +0100

rawtherapee (4.0.9-1) unstable; urgency=low

  * New upstream release (closes: #662753).
  * Bump Standards-Version to 3.9.3 (no changes necessary).
  * Bump debhelper compat from 8 to 9 (no changes necessary).
  * Enable hardened build flags.
  * Build-depend on libpng-dev instead of libpng12-dev (closes: #662491).
  * Refresh debian/patches/01-AboutThisBuild.patch to apply cleanly.
  * Remove debian/patches/ftbfs-gcc-4.7.diff as it's not needed anymore.
  * Split package as the arch-independent part got bigger.

 -- Philip Rinn <rinni@gmx.net>  Sun, 03 June 2012 18:50:12 +0100

rawtherapee (3.0.0~dfsg1-1.1) unstable; urgency=low

   * Non maintainer upload
   * Fix build failure with GCC 4.7. Closes: #667349.

 -- Matthias Klose <doko@debian.org>  Wed, 30 May 2012 06:08:03 +0000

=== debian/control ===
Source: rawtherapee
Section: graphics
Priority: optional
Maintainer: Philip Rinn <rinni@gmx.net>
Build-Depends: debhelper (>= 9), cmake (>= 2.6), imagemagick,
 libgtkmm-2.4-dev (>= 2.14), libgtk2.0-dev (>= 2.12), libtiff-dev,
 liblcms2-dev, libiptcdata0-dev, libpng-dev, libjpeg-dev, libbz2-dev
Standards-Version: 3.9.3
Homepage: http://www.rawtherapee.com

Package: rawtherapee
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, rawtherapee-data (= ${source:Version})
Description: Free RAW converter and digital photo processing software
 RawTherapee is used to adjust some of the most often changed parameters when
 optimizing digital images. A normal user often just wants to adjust the white
 balance or brightness of a photo he took. Instead of using a big and expensive
 image editor you could use a small and fast tool like RawTherapee.
 More and more cameras also support RAW formats. RAW files usually offer higher
 color depth than JPGs. So the adjustments are done with the high color depth 
 and then afterwards converted to or saved as JPGs. RawTherapee supports JPG, 
 PNG and TIFF. All image processing is done in 16 bit/channel mode.
 Different to other RAW converters it can use EAHD as demosaicing algorithm.
 The raw loading engine of RawTherapee is based on dcraw.

Package: rawtherapee-data
Architecture: all
Depends: ${misc:Depends}
Recommends: rawtherapee (= ${source:Version})
Replaces: rawtherapee (<< 4.0.9)
Breaks: rawtherapee (<< 4.0.9)
Description: Free RAW converter and digital photo processing software (data files)
 RawTherapee is used to adjust some of the most often changed parameters when
 optimizing digital images. A normal user often just wants to adjust the white
 balance or brightness of a photo he took. Instead of using a big and expensive
 image editor you could use a small and fast tool like RawTherapee.
 More and more cameras also support RAW formats. RAW files usually offer higher
 color depth than JPGs. So the adjustments are done with the high color depth 
 and then afterwards converted to or saved as JPGs. RawTherapee supports JPG, 
 PNG and TIFF. All image processing is done in 16 bit/channel mode.
 Different to other RAW converters it can use EAHD as demosaicing algorithm.
 The raw loading engine of RawTherapee is based on dcraw.
 .
 This package includes the data files.

=== debian/rules ===
#!/usr/bin/make -f

## Enable compiler hardening flags.
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=RelWithDebInfo -DCREDITSDIR=/usr/share/doc/rawtherapee -DLICENCEDIR=/usr/share/doc/rawtherapee

override_dh_install-arch:
	dh_install
	convert -geometry 32x32 rtdata/icons/hi32-app-rawtherapee.png debian/rawtherapee/usr/share/pixmaps/rawtherapee.xpm
	rm debian/rawtherapee/usr/share/doc/rawtherapee/LICENSE.txt

override_dh_install-indep:
	dh_install
	rm debian/rawtherapee-data/usr/share/rawtherapee/languages/LICENSE

SRC_VERSION := $(shell dpkg-parsechangelog | sed -ne 's/^Version: \(.*\)\.*-.*/\1/p')
.PHONY: get-orig-source
get-orig-source:
	rm -rf get-orig-source rawtherapee-$(SRC_VERSION).orig.tar.gz
	mkdir get-orig-source
	hg clone https://rawtherapee.googlecode.com/hg/ get-orig-source/rawtherapee-$(SRC_VERSION).orig
	hg -R get-orig-source/rawtherapee-$(SRC_VERSION).orig checkout $(SRC_VERSION)
    
	# Outdated documentation
	rm -r get-orig-source/rawtherapee-$(SRC_VERSION).orig/doc
	# Stuff we don't need
	rm get-orig-source/rawtherapee-$(SRC_VERSION).orig/languagePack.nsi
	rm -r get-orig-source/rawtherapee-$(SRC_VERSION).orig/tools
	# Mercurial files
	rm -r get-orig-source/rawtherapee-$(SRC_VERSION).orig/.hg
	rm get-orig-source/rawtherapee-$(SRC_VERSION).orig/.hgignore
	rm get-orig-source/rawtherapee-$(SRC_VERSION).orig/.hgtags
    
	tar cJf rawtherapee_$(SRC_VERSION).orig.tar.xz -C get-orig-source rawtherapee-$(SRC_VERSION).orig
	rm -rf get-orig-source

=== debian/watch ===
# I could not find a way to watch mercurial tags on googlecode.com
# so this is just to inform you that you can get the source via 
# 'debian/rules get-orig-source'
